local common = class()

function common:insidePolygon(polygon, point)
	local oddNodes = false
	local j = #polygon
	for i = 1, #polygon do
		if (polygon[i].y < point.y and polygon[j].y >= point.y or polygon[j].y < point.y and polygon[i].y >= point.y) then
			if (polygon[i].x + ( point.y - polygon[i].y ) / (polygon[j].y - polygon[i].y) * (polygon[j].x - polygon[i].x) < point.x) then
				oddNodes = not oddNodes;
			end
		end
		j = i;
	end
	return oddNodes 
end

function common:check_mana(mana_percentage)
	if (player.mana / player.maxMana) * 100 >= mana_percentage then
		return true
	else
		return false
	end
end

function common:getClosestObj(source_obj,table_obj)
    local mindist = math.huge
    local minobj = nil
    for _,obj in pairs(table_obj) do
        local dist = obj:dist(source_obj.pos)
        if dist < mindist then
            mindist = dist
            minobj = obj
        end
    end
    return minobj
end

function common:concatArray(a, b)
	local result = {table.unpack(a)}
	table.move(b, 1, #b, #result + 1, result)
	return result
  end

return common
