local damage = module.internal("damage")
local ts = module.internal("TS")
local pred = module.internal("pred")
local orb = module.internal("orb")

local spell = class()
local getDmg = damage.spell
local getTar = ts.get_result

function spell:__init(menu)
    self:bindToMenu(menu)
end

function spell:bindToMenu(menu)
    self.slotname = ({"W","E","R",[0]="Q"})[self.slot]
    self.menu = menu:menu(self.slotname, self.slotname)
    if (self.makeMenu) then
        self:makeMenu()
    end
    return self;
end

function spell:usable()
    return player:spellState(self.slot) == SpellState.Ready
end

function spell:getRange()
    return self.pred.range
end

function spell:damage(target)
    return damage.spell(player, target, self.slot)
end

function spell:draw()
end

function spell:level()
    return player:spellSlot(self.slot).level
end

function spell:canKill(target)
    return damage.spell(player, target, self.slot) > target.health
end

function spell:updateTarget(filter)
    local res = getTar(filter, nil, false, true)
    if not res or not res.obj then
        return
    end
    if res.obj:isValidTarget(self.maxRange, true, player.pos, false, false, 1., false) then 
        return res.obj
    end
end

function spell:onTick()
end


return spell